unit SubEx;

interface

uses
  Windows, Messages, SysUtils, Classes, Forms, Dialogs,
  WndSub32, Buttons, Controls, StdCtrls, ExtCtrls;

const
  MyID = 1234;   //unique id constant, just any number

type
  TMain = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Choose: TRadioGroup;
    SS: TButton;
    MsgLB: TListBox;
    Button3: TButton;
    Label1: TLabel;
    MsgLabel: TLabel;
    before: TRadioButton;
    after: TRadioButton;
    Label2: TLabel;
    Subclass321: TSubclass32;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure SSClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ChooseClick(Sender: TObject);
    procedure beforeClick(Sender: TObject);
    procedure afterClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Subclass321MsgReceived(const Wnd: Integer;
  var Msg: Cardinal; var wParam, lParam: Longint; const ProcessId: Integer;
  rmFlag: TWhen; var return: Longint; var CallDefWndproc: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Main: TMain;

implementation

{$R *.DFM}

procedure TMain.Button1Click(Sender: TObject);
var Wnd: hWnd;
begin
  Wnd := FindWindow('Notepad',NIL); //locate Notepad window
  if (Wnd = 0) then
    ShowMessage('Notepad window not found!')
  else
    AppendMenu(GetSubMenu(GetMenu(Wnd),1), //menu handle of notepad
               MF_STRING,    //Just by string
               MyID,        //unique menu ID
               'My Item!'); //Item to add


end;

procedure TMain.Button2Click(Sender: TObject);
begin
  WinExec('Notepad.exe',SW_SHOW);
end;

procedure TMain.SSClick(Sender: TObject);
var Wnd: hWnd;
begin
  with Subclass321 do begin
    Wnd := FindWindow('Notepad',NIL); //locate Notepad window
    if (Wnd = 0) then
      ShowMessage('Notepad window not found!')
    else
    begin
      WindowHandle := Wnd;
      start := NOT(start);           //start or stop the subclass
      if (start) then begin
        before.enabled := false;
        after.enabled := false;
        ss.caption := 'Stop!';
      end
      else
      begin
        before.enabled := true;
        after.enabled := true;
        ss.caption := 'Start!';
      end;
    end;
  end;
end;

procedure TMain.Button3Click(Sender: TObject);
begin
  MsgLB.clear;
end;

procedure TMain.ChooseClick(Sender: TObject);
begin
  ss.enabled := true;
  case choose.itemindex of
    0: Messagebox(handle,'Click Start if it''s not already!'#10'Try to click on a menu item of notepad.  If rmBeforeDefProc is checked, '+
                'then the menu click will never get passed.','Note',mb_taskmodal);
    1: Messagebox(handle,'Click Start if it''s not already!'#10'Click on any menu item of notepad.  If rmBeforeDefProc is checked, '+
                'any item you click will cause the File|Open item to be clicked because we '+
                'change the value of the wParam to the File|Open menu id.','Note',mb_taskmodal);
    2: Messagebox(handle,'Click Start if it''s not already!'#10'Click on the Append Menu button.  Look under the Edit| sub menu.  It added a new item.'+
                ' Now try clicking on that item, it will note to you that your item is clicked.','Note',mb_taskmodal);
    3:
      begin
        Messagebox(handle,'Click Start if it''s not already!'#10'Watch the listbox trace the messages.',
                   'Note',mb_taskmodal);
        main.Clientheight := 305;
        MsgLB.clear;
      end
  else
    main.clientheight := 145;
  end;
end;

procedure TMain.beforeClick(Sender: TObject);
begin
  Subclass321.ReceiveMessages := rmBeforeDefProc;
end;

procedure TMain.afterClick(Sender: TObject);
begin
  Subclass321.ReceiveMessages := rmAfterDefProc;
end;

procedure TMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Subclass321.start := FALSE;    //Be sure to stop the subclass when your application terminates!
                                 //Even though on destroy, the control attempts to stop the subclass
                                 //automatically, it is not reliable on every application.
                                 //This bug is noted and should be fixed in the next release.
                                 //In the mean time, just make sure you manually stop it if it is started
end;

procedure TMain.Subclass321MsgReceived(const Wnd: Integer;
  var Msg: Cardinal; var wParam, lParam: Longint; const ProcessId: Integer;
  rmFlag: TWhen; var return: Longint; var CallDefWndproc: Boolean);
var menu,
    sub_menu,
    item_id: integer;
    MsgStr: string;
    txt: array[0..50] of char;
begin
  if (choose.itemindex = 0) then begin
    if (msg = WM_COMMAND)and(lParam = 0) then   //if it's a menu message
      CallDefWndProc := FALSE;                  //Indicate to NOT call default window procedure
  end
  else
  if (choose.itemindex = 1) then begin
    if (msg = WM_COMMAND)and(lParam=0) then begin   //if it's a menu message
      menu := GetMenu(Wnd);                         //Get menu handle of window
      sub_menu := GetSubMenu(menu,0);               //get handle of the File sub menu
      item_id := GetMenuItemId(sub_menu,1);         //get handle of the File|Open ID
      wParam := item_id;                            //change wParam to Open ID
    end;
  end
  else
  if (choose.itemindex = 2) then begin
    if (msg = WM_COMMAND)and(lParam = 0) then       //if it's a menu message
      if (wParam = MyID) then                       //if wParam is YOUR menu ID
      begin
        StrPCopy(txt,'Just clicked your menu item id!!!');
        SendMessage(FindWindowEx(Subclass321.WindowHandle,0,'Edit',nil),
                    EM_REPLACESEL,
                    0,
                    LongInt(@txt[0]));
      end;

  end
  else
  if (choose.itemindex = 3) then begin
    MsgStr := Subclass321.MsgToStr(msg);                            //Using the MsgToStr method
    if MsgStr = 'Unknown' then                                 //if it's an unknown message, then
      MsgStr := Concat('WM_USER + ',inttohex(msg-WM_USER,4));  //get it's hex value and add it
    MsgLB.items.add(MsgStr);
    MsgLabel.caption := MsgStr;
  end;
end;

end.
